/* 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or 
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package jPong;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;


/**
 * @author Copyright (C) 2010
 * @author TomDalek
 * @see <a href="http://www.gnu.org/licenses/gpl.html">The GNU Public License (GPL)</a>
 */
public class MyKeyListener implements KeyListener {
	private Viewer viewer;
	
	public MyKeyListener(Viewer v){
		viewer = v;
		
		System.out.println("Keys:");
		System.out.println("h - home the view");
//		System.out.println("o - toggle overlay visibility");
//		System.out.println("z - toggle wireframe");
//		System.out.println("x - toggle flat shading");
//		System.out.println("c - toggle cull faces");
	}
	
    public void keyPressed(KeyEvent e) {
    	
    	switch (e.getKeyCode()) { 
    	
    	case KeyEvent.VK_ESCAPE :
    		//exit();
    		break;
    	// h - go Home
    	case KeyEvent.VK_H :
    	case KeyEvent.VK_NUMPAD0 :
    		viewer.homeView();
    		break;
    	
    	case KeyEvent.VK_F :
    	case KeyEvent.VK_NUMPAD1 :
    		viewer.frontView();
    		break;    	
    	
    	case KeyEvent.VK_T :
    	case KeyEvent.VK_NUMPAD7 :
    		viewer.topView();
    		break;
    	
    	case KeyEvent.VK_R :
    	case KeyEvent.VK_NUMPAD3 :
    		viewer.rightView();
    		break;

    	case KeyEvent.VK_SEPARATOR :
//    		viewer.shapeView();
    		break;
    	
    		
    		
//    	case KeyEvent.VK_M :
//    		MasterListener.mp3player.interrupt();
//    		System.out.println("Mute");
//    		break;
    		
    		
    		
//    	//=========
//    	case KeyEvent.VK_Z :
//    		viewer.toggleWireframe();
//    		break;
//    	
//    	case KeyEvent.VK_X :
//    		viewer.toggleShading();
//    		break;
//
//    	case KeyEvent.VK_C :
//    		viewer.toggleCullFaces();
//    		break;
//    	
//    	case KeyEvent.VK_V :
//    		viewer.toggleAverage();
//    		break;
//
//    	
//    	//=========  	
//    	// toggle visibility
//    		
//    	case KeyEvent.VK_O :
//    		MasterListener.overlay.toggleVisibility();
//    		break;

    	}

    	
    	
    }
     
	public void keyReleased(KeyEvent e) {
	}
     
	public void keyTyped(KeyEvent e) {
	}
	
}