/* 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or 
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package jPong;

import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseWheelEvent;

import javax.swing.event.MouseInputAdapter;

/**
 * @author Copyright (C) 2010
 * @author TomDalek
 * @see <a href="http://www.gnu.org/licenses/gpl.html">The GNU Public License (GPL)</a>
 */
public class MyMouseListener extends MouseInputAdapter {
	private Viewer viewer;
	
	public MyMouseListener(Viewer v){
		viewer = v;
		
		System.out.println("Mouse buttons:");
		System.out.println("Left      - grab the player");
		System.out.println("Middle    - orbit the view");
		System.out.println("Rollup    - zoomin the view");
		System.out.println("Rolldown  - zoomout the view");
		System.out.println("Right     - pan the view");
	}
	
	public void mousePressed(MouseEvent e) {
		if ((e.getModifiers() & InputEvent.BUTTON1_MASK) != 0) {
			viewer.setLeftPressed(true, e.getX(), e.getY());
		}	
		if ((e.getModifiers() & InputEvent.BUTTON2_MASK) != 0) {
			viewer.setMiddlePressed(true, e.getX(), e.getY());
		}
		if ((e.getModifiers() & InputEvent.BUTTON3_MASK) != 0) {
			viewer.setRightPressed(true, e.getX(), e.getY());
		}
	}
	
	public void mouseReleased(MouseEvent e) {
		if ((e.getModifiers() & InputEvent.BUTTON1_MASK) != 0) {
			viewer.setLeftPressed(false, e.getX(), e.getY());
		}
		if ((e.getModifiers() & InputEvent.BUTTON2_MASK) != 0) {
			viewer.setMiddlePressed(false, e.getX(), e.getY());
		}
		if ((e.getModifiers() & InputEvent.BUTTON3_MASK) != 0) {
			viewer.setRightPressed(false, e.getX(), e.getY());
		}
	}

	public void mouseDragged(MouseEvent e) {

		if (viewer.getmLeftPressed()) {
			viewer.movePlayer(e.getX(),e.getY());			
		}
		
		if (viewer.getmMiddlePressed()) {
			viewer.rotateView(e.getX(), e.getY());	
		}
		
		if (viewer.getmRightPressed()){			
			if (e.isControlDown())
				viewer.flyInView(e.getX(), e.getY());
			else
				viewer.panView(e.getX(), e.getY());			
		}
			
		
	}
	
    public void mouseWheelMoved(MouseWheelEvent e) {		
		viewer.rollZoomView(e.getWheelRotation());
    }  
}
