/* 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or 
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package jPong;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Properties;

import javax.swing.UIManager;

/**
 * JPong's wrapper for the Properties class.
 *  
 * @author Copyright (C) 2010
 * @author TomDalek
 * @see <a href="http://www.gnu.org/licenses/gpl.html">The GNU Public License (GPL)</a>
 *
 */
public class MyProperties extends Properties {
	private static final long serialVersionUID = 1L;
	
	private String propertiesFile;
	
	public MyProperties(String file){
		this.propertiesFile = file;			
	}

	public void load() throws FileNotFoundException, IOException {
		super.load(new FileInputStream(propertiesFile));
	}
	
	
	public void store() throws FileNotFoundException, IOException {
		OutputStream out = new FileOutputStream(propertiesFile);
		String header = "JPong properties file.";
		super.store(out, header);
		out.flush();
		out.close();
	}

	public void makeDefaultProperties(){
		setProperty("port", "1212");
		setProperty("ip", "127.0.0.1");
		setProperty("name", "Alice");
		setProperty("look&feel",  UIManager.getSystemLookAndFeelClassName());
		setProperty("decorate", "false");
	}

}