/* 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or 
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package jPong;

import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLEventListener;

import org.jbox2d.common.Vec2;


/**
 * Draw the world of the JBox2D (stored in the MyWorld class).<br>
 * (Previously BoxTextured)
 * 
 * @author Copyright (C) 2010
 * @author TomDalek
 * @author Piotr Korzeniewski
 * @see <a href="http://www.gnu.org/licenses/gpl.html">The GNU Public License (GPL)</a>
 */
class MyWorldRenderer implements GLEventListener {
    
    MyWorld myWorld = new MyWorld();
    Vec2 position;
    float angle;
    
    
    /** Called by the drawable to initiate OpenGL rendering by the client.
     * After all GLEventListeners have been notified of a display event, the
     * drawable will swap its buffers if necessary.
     * @param drawable The GLAutoDrawable object.
     */    
    public void display(GLAutoDrawable drawable) {
    	myWorld.ball.display(drawable);
    	
    	myWorld.player1.display(drawable);
    	myWorld.player2.display(drawable);
    	
    	myWorld.leftWall.display(drawable);
    	myWorld.rightWall.display(drawable);
    	myWorld.topWall.display(drawable);
    	myWorld.bottomWall.display(drawable);

    	myWorld.forceField.display(drawable);
    	
    	myWorld.displayGround(drawable);
    	
    	if(MasterListener.winner == MasterListener.Winner.You) {
    		myWorld.displayStrokeText(drawable, "You won!", 0.2f, 1.0f, 0.0f, 0.0f, 35.0f);
    	}
    	else if(MasterListener.winner == MasterListener.Winner.Enemy) {
    		myWorld.displayStrokeText(drawable, "You lost..", 0.2f, 1.0f, 0.0f, 0.0f, 35.0f);
    	}
    }

    
    /** Called by the drawable immediately after the OpenGL context is
     * initialized for the first time. Can be used to perform one-time OpenGL
     * initialization such as setup of lights and display lists.
     * @param gLDrawable The GLAutoDrawable object.
     */
    public void init(GLAutoDrawable gLDrawable) {
//        final GL gl = gLDrawable.getGL();      
        
    }

    public void reshape(GLAutoDrawable gLDrawable, int x, int y, int width, int height) {

    }

    /** Called when the display mode has been changed.  <B>!! CURRENTLY UNIMPLEMENTED IN JOGL !!</B>
	 * @param gLDrawable The GLAutoDrawable object.
	 * @param modeChanged Indicates if the video mode has changed.
	 * @param deviceChanged Indicates if the video device has changed.
	 */
	public void displayChanged(GLAutoDrawable gLDrawable, boolean modeChanged, boolean deviceChanged) {
	}


}