/* 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or 
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package jPong;

import java.nio.IntBuffer;

import javax.media.opengl.GL;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.glu.GLU;

import com.sun.opengl.util.BufferUtil;
import com.sun.opengl.util.GLUT;

/**
 * Renders an overlay at the bottom of the screen.
 * 
 * @author Copyright (C) 2010
 * @author TomDalek
 * @see <a href="http://www.gnu.org/licenses/gpl.html">The GNU Public License (GPL)</a>
 *
 */
public class Overlay extends Shape {
    protected String message;
    
    
    
    Overlay(){
    	this.message = "Let's see some action!";
    	this.trsX = 10;
    	this.trsY = 10;
    }

	public Overlay(String message){
    	this.message = message;
    	this.trsX = 10;
    	this.trsY = 10;
    }
	
	public void display(GLAutoDrawable drawable){
		displayOverlay(drawable);
	}
	
	protected void displayOverlay(GLAutoDrawable drawable){
    		float height = drawable.getHeight();
    		float width = drawable.getWidth();
	
		   GL gl = drawable.getGL();
		   GLU glu = new GLU();
		   GLUT glut = new GLUT();
		   

	        // Store old matrices
	        gl.glMatrixMode(GL.GL_MODELVIEW);
	        gl.glPushMatrix();
	        gl.glLoadIdentity();
	        gl.glMatrixMode(GL.GL_PROJECTION);	        
	        gl.glPushMatrix();
	        gl.glLoadIdentity();
//
	        gl.glViewport(0, 0, drawable.getWidth(), drawable.getHeight());

	        // Store enabled state and disable lighting, texture mapping and the depth buffer
	        gl.glPushAttrib(GL.GL_ENABLE_BIT);
//	        gl.glDisable(GL.GL_BLEND);
	        gl.glDisable(GL.GL_LIGHTING);
	        gl.glDisable(GL.GL_TEXTURE_2D);
	        gl.glDisable(GL.GL_DEPTH_TEST);
	        
//	        gl.glDisable(GL.GL_CULL_FACE);

	        // Retrieve the current viewport and switch to orthographic mode
	        IntBuffer viewPort = BufferUtil.newIntBuffer(4);
	        gl.glGetIntegerv(GL.GL_VIEWPORT, viewPort);
	        glu.gluOrtho2D(0, viewPort.get(2), viewPort.get(3), 0);
	        
	        gl.glColor4f(1.0f, 1.0f, 1.0f, 0.2f);
	        gl.glBegin(GL.GL_QUADS);
	        gl.glVertex3f( 0.0f, height, 0.0f);
	        gl.glVertex3f(width, height, 0.0f);
	        gl.glVertex3f(width, height - 26.0f, 0.0f);
	        gl.glVertex3f( 0.0f, height - 26.0f, 0.0f);
	        gl.glEnd();
	        

	        // Render the text
	        gl.glColor3f(1, 1, 1);

	        float x = this.trsX;
	        float y = height - this.trsY;

            gl.glRasterPos2f(x, y);
            glut.glutBitmapString(GLUT.BITMAP_HELVETICA_12, message);

	        // Restore enabled state
	        gl.glPopAttrib();

	        // Restore old matrices
	        gl.glPopMatrix();
	        gl.glMatrixMode(GL.GL_MODELVIEW);
	        gl.glPopMatrix();		
	}

}
