/* 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or 
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package jPong;

import javax.media.opengl.GLAutoDrawable;

/**
 * Extends Overlay with the fps, pps and score message.
 * 
 * @author Copyright (C) 2010
 * @author TomDalek
 * @author Piotr Korzeniewski
 * @see <a href="http://www.gnu.org/licenses/gpl.html">The GNU Public License (GPL)</a>
 *
 */
public class OverlayFPS extends Overlay {
	int frames = 0;
	int fps = 0;
	int pps = 0;
	
	// Get current time
	long start = System.currentTimeMillis();
	// Do something ... 
	// Get elapsed time in milliseconds
	long elapsedTimeMillis = System.currentTimeMillis()-start;
	
	OverlayFPS(){
		message = "Counting fps...";
	}
	
	void displayIfVisible(GLAutoDrawable drawable, int p1score, int p2score){
		if (super.isVisible()) {
		frames++;		
		elapsedTimeMillis = System.currentTimeMillis()-start;
		
		if (elapsedTimeMillis > 1000) {	
			fps = frames;
			pps = MasterListener.packets;
			message =
					fps + " fps   |   " + 
					pps + " pps   |   " +
					MasterListener.myWorldRenderer.myWorld.player1.name  + " (you) : "   + p1score + "   |   " + 
					MasterListener.myWorldRenderer.myWorld.player2.name + " (enemy) : " + p2score;
			
			frames = 0;
			MasterListener.packets = 0;
			start = System.currentTimeMillis();
		}

		displayOverlay(drawable);
		}
	}	
}
