/* 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or 
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package jPongMusic;

import jPong.MasterListener;

import java.io.BufferedInputStream;
import java.io.InputStream;
import java.util.ArrayList;

import javazoom.jl.decoder.JavaLayerException;
import javazoom.jl.player.AudioDevice;
import javazoom.jl.player.FactoryRegistry;
import javazoom.jl.player.Player;


/**
 * Plays a play-list of mp3 files (from the resources) in a new thread.<br>
 * This version plays mp3 from within the .jar file.
 * This version uses a play list.
 * This version is interruptible.
 * 
 * @author TomDalek, Copyright (C) 2010.
 * @see <a href="http://www.gnu.org/licenses/gpl.html">The GNU Public License (GPL)</a>
 */
public class MP3player implements Runnable {
//class MP3player extends Thread {
	
	public void run() {
		this.play();
		System.out.println("Exiting player.");
	}

	
	public void play(){
		ArrayList<String> playlist = new ArrayList<String>();

		playlist.add("/data/01 I Like Jump Rope.mp3");
		playlist.add("/data/02 A Well Worked Analogy.mp3");
		playlist.add("/data/03 Termosdynamik.mp3");
		

//		while (!Thread.currentThread().isInterrupted()){
		while (MasterListener.playMusic){
			for (String filename : playlist){
				try {
					playMP3(filename);
				} catch (JavaLayerException e) {
					e.printStackTrace();
					break;
				} catch (InterruptedException e) {
					System.out.println("Music switched off.");
					break;
				}
			}
		}
	}
	
	
	
	public void playMP3(String filename) throws JavaLayerException, InterruptedException{
//		System.out.println("playing "+filename+"...");
		InputStream in = null;		
		try {
			in = getURLInputStream(filename);
		} catch (Exception e) {
			e.printStackTrace();
			throw new JavaLayerException("Problem playing file "+filename, e);
		}

		AudioDevice dev = getAudioDevice();
		Player player = new Player(in, dev);

		while (!player.isComplete()){
//			player.play(38); // about a second
			player.play(16);
//			if (Thread.currentThread().isInterrupted()){
			if (!MasterListener.playMusic){
//				System.out.println("interupted2");
				throw new InterruptedException();
			}
		}
	}
	
	
	protected InputStream getURLInputStream(String filename) throws Exception {
		InputStream fin = getClass().getResourceAsStream(filename);
		BufferedInputStream bin = new BufferedInputStream(fin);
		return bin;
	}
	
	protected AudioDevice getAudioDevice() throws JavaLayerException {
		return FactoryRegistry.systemRegistry().createAudioDevice();
	}
	
}

