/* 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or 
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package jPongSwing;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;

/**
 * About dialog.
 * @author TomDalek, Copyright (C) 2010.
 * @see <a href="http://www.gnu.org/licenses/gpl.html">The GNU Public License (GPL)</a>
 */
public class SwingAbout extends JDialog {
	private static final long serialVersionUID = 1L;

	
	public SwingAbout(JFrame parent) {
		super(parent, "About JPong", true);		
		String version = "0.6.2";
		
		// ===========================
		// Layout {
		setLayout(new BoxLayout(getContentPane(), BoxLayout.Y_AXIS));
		((JComponent) getContentPane()).setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		add(Box.createRigidArea(new Dimension(300,30)));
		
		
		JLabel logoLabel = new JLabel();
		Icon logoIcon = new ImageIcon(getClass().getResource("/data/logo.png"));
		logoLabel.setIcon(logoIcon);
		logoLabel.setAlignmentX(CENTER_ALIGNMENT);
		((JComponent) getContentPane()).setBackground(Color.getHSBColor(0.55f, 0.34f, 0.73f));
		add(logoLabel);		
		add(Box.createRigidArea(new Dimension(0,20)));
		
		
		// In alphabetical order! :)
		JLabel tomLabel = new JLabel("Tom Dalek");
		tomLabel.setAlignmentX(CENTER_ALIGNMENT);
		tomLabel.setForeground(Color.getHSBColor(0.55f, 0.26f, 0.97f));
		add(tomLabel);

		JLabel piotrLabel	= new JLabel("Piotr Korzeniewski");
		piotrLabel.setAlignmentX(CENTER_ALIGNMENT);
		piotrLabel.setForeground(Color.getHSBColor(0.55f, 0.26f, 0.97f));
		add(piotrLabel);
		
		add(Box.createRigidArea(new Dimension(0,20)));
		
		JLabel musicLabel	= new JLabel("Music by Ozzed");
		musicLabel.setAlignmentX(CENTER_ALIGNMENT);
		musicLabel.setForeground(Color.getHSBColor(0.55f, 0.3f, 0.90f));
		add(musicLabel);
		
		add(Box.createRigidArea(new Dimension(0,20)));
		
		
		JLabel versionLabel	= new JLabel("Version: " + version);
		versionLabel.setAlignmentX(CENTER_ALIGNMENT);
		versionLabel.setForeground(Color.getHSBColor(0.55f, 0.3f, 0.90f));
		add(versionLabel);		
		
		add(Box.createRigidArea(new Dimension(0,20)));
		
		JButton okButton = new JButton("OK");
		okButton.setAlignmentX(CENTER_ALIGNMENT);		
		add(okButton);
		
	    // } Layout
	    // ==================
	    
	    pack();
	    Dimension minimumSize = new Dimension(getSize());
	    setMinimumSize(minimumSize);	    
	    setLocationRelativeTo(null);
	    
		
	    // ==================		
		// Listeners {
		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				dispose();
			}
		});
		// } Listeners
	    // ==================
		
	}
}
